#ifndef _X86_64_MAGIC_H
#define _X86_64_MAGIC_H

#define X86_64_POINTER_SIZE 8	// of analyzed system
#define X86_64_INTEGER_SIZE 8	// of analyzed system

// MAGIC section...

// Virtual Page Table (or PaGe Directory (PGD))
#define X86_64_VPT_MAGIC_ADDR 0x00000000	// where to start looking for VPT 
//Used to be 0x00300000, but windows seems to store this address
//on lower addresses

#define X86_64_VPT_MAGIC_BS 4096	// size of block with VPT

#define X86_64_VPT_MAGIC_COUNT 500000	// how many page to check, when looking for VPT
#define X86_64_VPT_MAGIC_ERR 1		// how many error values can be found

#define X86_64_VPT_MIN_REC 1		// at least how many valid entries require
#define X86_64_VPT_MAGIC_ERR_RATIO 3	// (#records / #errors) must be at least

//_2L constants are for function x86_64_looks_like_page_table

#define X86_64_VPT_MAGIC_ERR_2L 1	// how many error values can be found
#define X86_64_VPT_MIN_REC_2L 1		// at least how many valid entries require
#define X86_64_VPT_MAGIC_ERR_RATIO_2L 3	// (#records / #errors) must be at least


#endif
