
#include "globals.h"

/*
 * Function that print size in 
 * human readable format.
 *
 * human_print(value)
 * return 0 on success (always;)
 */

int human_print(u_int64_t value) {

	if ((value) > GB_1) {
		printf("%llu GB",value/(GB_1));
		return 0;
	}
	if (value > MB_1) {
		printf("%llu MB",value/(MB_1));
		return 0;
	} 
	if (value > KB_1) {
		printf("%llu KB",value/KB_1);
		return 0;
	} 
	printf("%llu Bytes)\n",value);
	return 0;
}

int hexprint(unsigned char *pointer, 
		u_int64_t size_read_addr, 
		u_int64_t read_addr) 
{

	u_int64_t rpl=0; // RecordsPerLine
	rpl=( (LINE_SIZE / 4) -1 ) & ~3 ; 
	// for each character, hexa number, (2 chars) 
	// space (1 char) and char itself (1 char) is printed
	// on standard 80 chars terminal, this makes 16 bytes per line

	// print loop
	printf("%llx: ",read_addr);
	u_int64_t ui=0,uj=0;
	for (ui=0,uj=0;ui<size_read_addr;ui++) {
		printf("%02x ",pointer[ui]);
		uj++;
		if ((uj == rpl) || (ui == size_read_addr-1)) { 
			//end of line
			if (ui == size_read_addr-1) { 
				//special case: last line
				int i=uj;
				for (;i<rpl;i++) {
					printf("   ");
				} 
			}
			u_int64_t ui2=ui-uj+1;
			putc(' ',stdout);
			for(;ui2<=ui;ui2++) {
				int one=pointer[ui2];
				if (isprint(one) && ( one == ' ' || !isspace(one)) ) {
					// only printable chars,
					// but not end of lines,
					// but yes space;)
					putc(one,stdout);
				} else {
					//non printable (in ascii)
					putc('.',stdout); 
				}
			}
			//printf("%d",i);
			printf("\n%llx: ",read_addr+ui+1);
			uj=0;
		}
	}
	return 0;
}	

