#ifndef _UNKNOWN_FUNCTIONS_H
#define _UNKNOWN_FUNCTIONS_H

/*
 *	Functions for analysing unknown based systems
*/

#include "../../globals.h"
#include "../functions_allos.h"
#include "../allos.h"
#include "magic.h" 

/*
 * Hook for proc_determine
 *
 * unknown_hook_proc_determine (u_int64_t *process)
 * return 0 on success 
 */

int unknown_hook_proc_determine(u_int64_t *process);


/*
 * Hook to determine aditional information,
 * once process structure is found.
 *
 * unknown_hook_proc_determine2 ()
 * return 0 on success 
 */

int unknown_hook_proc_determine2();

/*
 * Hook for listing processes
 *
 * unknown_hook_list_processes (pointer to VMA switch)
 * return 0 on success 
 */

int unknown_hook_list_processes(int *list_areas);


/*
 * Hook for matching process structure
 *
 * unknown_hook_verify_task_struct ( 
	pointer to hl size, 
	index in hl list,
	ver_addr (needed for bsd list,
	pointer to bsd list start
	pointer to found_os)
 * return 0 on success 
 */

int unknown_hook_verify_task_struct(int *hl_size, 
				int i, 
				u_int64_t ver_addr, 
				u_int64_t *bsd_list_start,
				int *found_os);


/*
 * Hook for matching process structure
 *
 * unknown_hook_verify_task_struct2 ( 
 *	found_os, start of non-cyclic hl, pointer to hl )
 *
 * return 0 on success 
 */

int unknown_hook_verify_task_struct2(int found_os, 
				u_int64_t bsd_list_start, 
				u_int64_t *list_start);


/*
 * Initialization function.
 */

int unknown_init(struct os_struct *);

#endif
